Package: gamair
Version: 1.0-2
Author: Simon Wood <simon.wood@r-project.org>
Maintainer: Simon Wood <simon.wood@r-project.org>
Title: Data for 'GAMs: An Introduction with R'
Description: Data sets and scripts used in the book 'Generalized Additive 
             Models: An Introduction with R', Wood (2006,2017) CRC.
Depends: R (>= 2.10)
Suggests: mgcv, lattice, MASS, nlme, lme4, geoR, survival
License: GPL (>= 2)
NeedsCompilation: no
Packaged: 2019-08-23 12:14:27 UTC; sw283
Repository: CRAN
Date/Publication: 2019-08-23 12:40:02 UTC
Built: R 4.4.0; ; 2024-05-04 02:24:23 UTC; unix

Package: gamair
Version: 1.0-2
Author: Simon Wood <simon.wood@r-project.org>
Maintainer: Simon Wood <simon.wood@r-project.org>
Title: Data for 'GAMs: An Introduction with R'
Description: Data sets and scripts used in the book 'Generalized Additive 
             Models: An Introduction with R', Wood (2006,2017) CRC.
Depends: R (>= 2.10)
Suggests: mgcv, lattice, MASS, nlme, lme4, geoR, survival
License: GPL (>= 2)
NeedsCompilation: no
Packaged: 2019-08-23 12:14:27 UTC; sw283
Repository: CRAN
Date/Publication: 2019-08-23 12:40:02 UTC
Built: R 4.4.0; ; 2024-05-30 02:48:04 UTC; unix

# R code for chapter 5 of Wood (2006) "GAMs: An Introduction with R"

## 5.1 Cherry trees again

library(mgcv)
data(trees)
ct1<-gam(Volume~s(Height)+s(Girth),
         family=Gamma(link=log),data=trees)
ct1
par(mfrow=c(1,2))
plot(ct1,residuals=TRUE)

## 5.1.1 Finer control of gam

ct2 <- gam(Volume~s(Height,bs="cr")+s(Girth,bs="cr"),
           family=Gamma(link=log),data=trees)
ct2

ct3 <- gam(Volume ~ s(Height)+s(Girth,bs="cr",k=20),
           family=Gamma(link=log),data=trees)
ct3

ct4 <- gam(Volume ~ s(Height) + s(Girth),
           family=Gamma(link=log),data=trees,gamma=1.4)
ct4
plot(ct4,residuals=TRUE)

## 5.1.2 Smooths of several variables

ct5 <- gam(Volume ~ s(Height,Girth,k=25),
           family=Gamma(link=log),data=trees)
ct5
plot(ct5,too.far=0.15)

ct6 <- gam(Volume ~ te(Height,Girth,k=5),
           family=Gamma(link=log),data=trees)
ct6
plot(ct6,too.far=0.15)

## 5.1.3 Parametric model terms

gam(Volume~Height+s(Girth),family=Gamma(link=log),data=trees)
trees$Hclass <- factor(floor(trees$Height/10)-5,
                labels=c("small","medium","large"))

ct7 <- gam(Volume ~ Hclass+s(Girth),
           family=Gamma(link=log),data=trees)
par(mfrow=c(1,2))
plot(ct7,all.terms=T)

anova(ct7)
AIC(ct7)
summary(ct7)

## 5.2 Brain imaging example
## 5.2.1 Preliminary modelling
library(gamair)
data(brain)
brain <- brain[brain$medFPQ>5e-3,] # exclude 2 outliers
m0 <- gam(medFPQ~s(Y,X,k=100),data=brain)
gam.check(m0) 

e <- residuals(m0); fv <- fitted(m0)
lm(log(e^2)~log(fv))

m1<-gam(medFPQ^.25~s(Y,X,k=100),data=brain)
gam.check(m1)

m2<-gam(medFPQ~s(Y,X,k=100),data=brain,family=Gamma(link=log),optimizer="perf")

mean(fitted(m1)^4);mean(fitted(m2));mean(brain$medFPQ)
m2

vis.gam(m2,plot.type="contour",too.far=0.03,
        color="gray",n.grid=60,zlim=c(-1,2))

## 5.2.2 Would an additive structure be better?
m3 <- gam(medFPQ~s(Y,k=30)+s(X,k=30),data=brain,
          family=Gamma(link=log),optimizer="perf")

m3
anova(m3,m2,test="F")

m4 <- gam(medFPQ~s(Y,k=30)+s(X,k=30)+s(Y,X,k=100),data=brain,
      family=Gamma(link=log),optimizer="perf")

## 5.2.3 Isotropic or tensor product smooths?

tm<-gam(medFPQ~te(Y,X,k=10),data=brain,family=Gamma(link=log),
        optimizer="perf")
tm1<-gam(medFPQ~s(Y,k=10,bs="cr")+s(X,bs="cr",k=10),
         data=brain,family=Gamma(link=log),optimizer="perf")

tm1
tm
anova(tm1,tm,test="F")

## 5.2.4 Detecting symmetry (with `by' variables)
brain$Xc <- abs(brain$X - 64.5)
brain$right <- as.numeric(brain$X<64.5)
m.sy <- gam(medFPQ~s(Y,Xc,k=100),data=brain,
            family=Gamma(link=log),optimizer="perf")
m.as <- gam(medFPQ~s(Y,Xc,k=100)+s(Y,Xc,k=100,by=right),
            data=brain,family=Gamma(link=log),optimizer="perf")
m.sy
m.as

anova(m.sy,m.as,test="F")
anova(m.as)

par(mfrow=c(1,3))
vis.gam(m.sy,plot.type="contour",view=c("Xc","Y"),too.far=.03,
        color="gray",n.grid=60,zlim=c(-1,2),main="both sides")
vis.gam(m.as,plot.type="contour",view=c("Xc","Y"),
        cond=list(right=0),too.far=.03,color="gray",n.grid=60,
        zlim=c(-1,2),main="left side")
vis.gam(m.as,plot.type="contour",view=c("Xc","Y"),
        cond=list(right=1),too.far=.03,color="gray",n.grid=60,
        zlim=c(-1,2),main="right side")

## 5.2.5 Comparing two surfaces

brain1 <- brain
mu <- fitted(m2)
n<-length(mu)
ind <- brain1$X<60 & brain1$Y<20
mu[ind] <- mu[ind]/3
set.seed(1)
brain1$medFPQ <- rgamma(rep(1,n),mu/m2$sig2,scale=m2$sig2)

brain2=rbind(brain,brain1)
brain2$sample1 <- c(rep(1,n),rep(0,n))
brain2$sample0 <- 1 - brain2$sample1

m.same<-gam(medFPQ~s(Y,X,k=100),data=brain2,
            family=Gamma(link=log),optimizer="perf")
m.diff<-gam(medFPQ~s(Y,X,k=100)+s(Y,X,by=sample1,k=100),
            data=brain2,family=Gamma(link=log),optimizer="perf")

anova(m.same,m.diff,test="F")

## 5.2.6 Prediction with `predict.gam'

predict(m2)[1:5]
pv <- predict(m2,se=TRUE)
pv$fit[1:5]
pv$se[1:5]

predict(m2,type="response")[1:5]
pv <- predict(m2,type="response",se=TRUE)
pv$se[1:5]

pd <- data.frame(X=c(80.1,68.3),Y=c(41.8,41.8))
predict(m2,newdata=pd)
predict(m2,newdata=pd,type="response",se=TRUE)

predict(m3,newdata=pd,type="terms",se=TRUE)

#### Prediction with `lpmatrix'

Xp <- predict(m2,newdata=pd,type="lpmatrix")
fv <- Xp%*%coef(m2)
fv

d <- t(c(1,-1))
d%*%fv
d%*%Xp%*%m2$Vp%*%t(Xp)%*%t(d)

## 5.2.7 Variances of non-linear functions of the fitted model

ind <- brain$region==1& ! is.na(brain$region)
Xp <- predict(m2,newdata=brain[ind,],type="lpmatrix")

library(MASS)
br <- mvrnorm(n=1000,coef(m2),m2$Vp) # simulate from posterior

mean.FPQ<-rep(0,1000)
for (i in 1:1000)
{ lp <- Xp%*%br[i,]  # replicate linear predictor
  mean.FPQ[i] <- mean(exp(lp)) # replicate region 1 mean FPQ
}

mean.FPQ <- colMeans(exp(Xp%*%t(br)))

hist(mean.FPQ)

## 5.3 Air pollution in Chicago example

data(chicago)
ap0 <- gam(death~s(time,bs="cr",k=200)+pm10median+so2median+
           o3median+tmpd,data=chicago,family=poisson)
gam.check(ap0)

par(mfrow=c(2,1))
plot(ap0,n=1000)  # n increased to make plot smooth
plot(ap0,residuals=TRUE,n=1000)

chicago$death[3111:3125]

ap1<-gam(death~s(time,bs="cr",k=200)+s(pm10median,bs="cr")+
     s(so2median,bs="cr")+s(o3median,bs="cr")+s(tmpd,bs="cr"),
     data=chicago,family=poisson)

lag.sum <- function(a,l0,l1)
## l0 is the smallest lag, l1 the largest
{ n<-length(a)
  b<-rep(0,n-l1)
  for (i in 0:(l1-l0)) b <- b + a[(i+1):(n-l1+i)]
  b
}
death<-chicago$death[4:5114]
time<-chicago$time[4:5114]
o3 <- lag.sum(chicago$o3median,0,3)
tmp <- lag.sum(chicago$tmpd,0,3)
pm10 <- lag.sum(log(chicago$pm10median+40),0,3)
so2 <- lag.sum(log(chicago$so2median+10),0,3)

ap2 <- gam(death ~ s(time,bs="cr",k=200) +
                   te(o3,tmp,pm10,k=c(8,8,6)),family=poisson)

ap3 <- gam(death ~ s(time,bs="cr",k=200) + te(o3,tmp,k=8) +
                   s(pm10,bs="cr",k=6),family=poisson)


## 5.4 Mackerel egg survey example
## 5.4.1 Model development

data(mack)
mack$log.net.area <- log(mack$net.area)

gm <- gam(egg.count~s(lon,lat,bs="ts")+s(I(b.depth^.5),bs="ts")
          +s(c.dist,bs="ts")+s(salinity,bs="ts")+s(temp.surf,bs="ts")
          +s(temp.20m,bs="ts")+offset(log.net.area),
          data=mack,family=poisson,scale=-1,gamma=1.4)

gm1 <- gam(egg.count ~ s(lon,lat,bs="ts",k=100)+
           s(I(b.depth^.5),bs="ts") + s(c.dist,bs="ts") +
           s(temp.surf,bs="ts") + s(temp.20m,bs="ts") +
           offset(log.net.area),
           data=mack,family=poisson,scale=-1,gamma=1.4)
gm1

gm1a <- gam(egg.count~s(lon,lat,bs="ts",k=100)+
            s(I(b.depth^.5),bs="ts") + s(temp.20m,bs="ts")+
            offset(log.net.area),data=mack,family=poisson,
            scale=-1,gamma=1.4)

gm2<-gam(egg.count ~ s(lon,lat,bs="ts",k=40) +
         s(I(b.depth^.5),bs="ts") + s(c.dist,bs="ts") +
         s(temp.surf,bs="ts") + s(temp.20m,bs="ts") +
         offset(log.net.area),
         data=mack,family=negbin(c(.01,100)),
         control=gam.control(maxit=100),gamma=1.4,optimizer="perf")
gm2

## alternative, using more recent methods...

gm2a<-gam(egg.count ~ s(lon,lat,bs="ts",k=40) +
         s(I(b.depth^.5),bs="ts") + s(c.dist,bs="ts") +
         s(temp.surf,bs="ts") + s(temp.20m,bs="ts") +
         offset(log.net.area),data=mack,family=negbin(c(.1,10)),
         control=gam.control(maxit=100),gamma=1.4)
gm2a

anova(gm1a)

## 5.4.2 Model predictions
data(mackp)
data(coast)
mackp$log.net.area <- 0*mackp$lon # make offset column
lon<-seq(-15,-1,1/4);lat<-seq(44,58,1/4)
zz<-array(NA,57*57)
zz[mackp$area.index]<-predict(gm1a,mackp)

image(lon,lat,matrix(zz,57,57),col=gray(0:32/32),
      cex.lab=1.5,cex.axis=1.4)
contour(lon,lat,matrix(zz,57,57),add=TRUE)
lines(coast$lon,coast$lat,col=1)

library(MASS)
br1 <- mvrnorm(n=1000,coef(gm1a),gm1a$Vp)
Xp <- predict(gm1a,newdata=mackp,type="lpmatrix")
mean.eggs1 <- colMeans(exp(Xp%*%t(br1)))
hist(mean.eggs1)

f<-fitted(gm1a)
form<-egg.count~offset(log.net.area)+s(lon,lat,bs="ts",k=100)+
                s(I(b.depth^.5),bs="ts")+s(temp.20m,bs="ts")
mack.bs <- mack
n <- nrow(mack)
br <- matrix(0,0,length(coef(gm1a)))
for (i in 1:19)
{ e <- rpois(rep(1,n),f) - f
  y <- round(f+e*gm1a$sig2^.5) ## deal with overdispersion
  y[y<0] <- 0
  mack.bs$egg.count <- y
  sp <-
  gam(form,data=mack.bs,family=poisson,scale=-1,gamma=1.4)$sp
  b <- gam(form,data=mack,family=poisson,sp=sp,scale=-1)
  br <- rbind(br,mvrnorm(n=100,coef(b),b$Vp))
}
br <- rbind(br,mvrnorm(n=100,coef(gm1a),gm1a$Vp))
mean.eggs <- colMeans(exp(Xp%*%t(br)))
hist(mean.eggs)

## 5.5 Portuguese larks example

data(bird)
ind <- sample(1:25100,2000,replace=FALSE)
m2 <- gam(crestlark ~ s(x,y,k=100),data=bird,family=binomial,
          knots=bird[ind,],gamma=1.4)
m2

bird$n <- bird$y*0+1 # when summed, gives binomial denominator
bird$n[is.na(bird$crestlark)] <- NA
ba <- aggregate(data.matrix(bird),by=list(bird$QUADRICULA),
                FUN=sum,na.rm=TRUE)
ba$x <- ba$x / 25   # don't want locations summed!
ba$y <- ba$y / 25

m10 <- gam(cbind(crestlark,n-crestlark)~s(x,y,k=100),
             data=ba,family=binomial,gamma=1.4)
m10

library(geoR)
coords<-matrix(0,1004,2);coords[,1]<-ba$x;coords[,2]<-ba$y
gb<-list(data=residuals(m10,type="d"),coords=coords)
plot(variog(gb,max.dist=1e5))
plot(fitted(m10),residuals(m10))

mx <- sort(unique(bird$x));my<-sort(unique(bird$y))
nx<-length(mx);ny<-length(my)
ixm <- 1:nx;names(ixm)<-mx
ix <- ixm[as.character(bird$x)]
iym <- 1:ny;names(iym)<-my
iy <- iym[as.character(bird$y)]
um <- matrix(NA,nx,ny)
fv10 <- predict(m10,bird,type="response")
my<-my/1000;mx <- mx/1000
um[ix+(iy-1)*nx] <- fv10
image(mx,my,matrix(um,nx,ny),xlab="km east",ylab="km north")
contour(mx,my,matrix(um,nx,ny),add=TRUE)

## 5.6.1 Package `gam' (note need to run chicago pre-proc first)

detach(package:mgcv)  
library(gam)
library(akima) # needed for plotting
bfm <- gam(death~s(time,df=140)+lo(o3,tmp,span=.1),
           family=poisson,control=gam.control(bf.maxit=150))
summary(bfm)
plot(bfm,se=T,rug=F,phi=30,theta=-30)
detach(package:gam)

## 5.6.2 Package `gss'

library(gss)
ssm <- gssanova1(death~time+o3*tmp,family="poisson",nbasis=200)

summary(ssm)

tp <- seq(min(time),max(time),length=500)
fvt <- predict(ssm,newdata=data.frame(time=tp,
               o3=rep(mean(o3),500),tmp=rep(mean(tmp),500)),
               include=list("time"))
plot(tp,fvt,type="l",xlab="time",ylab="time effect")

m <- 40
o3m <- seq(min(o3),max(o3),length=m)
tmpm <- seq(min(tmp),max(tmp),length=m)
tmpp <- rep(tmpm,rep(m,m))
o3p <- rep(o3m,m)
pd <- data.frame(time=rep(0,m*m),o3=o3p,tmp=tmpp)
fv <- predict(ssm,newdata=pd,include=list("o3","tmp","o3:tmp"))
library(mgcv)
ind <- exclude.too.far(o3p,tmpp,o3,tmp,dist=0.04)
fv[ind] <- 0
persp(o3m,tmpm,matrix(fv,m,m),phi=30,theta=-30,zlab="o3*tmp",
      xlab="o3",ylab="tmp")

# R code for chapter 1 of Wood (2006) "GAMs: An Introduction with R"

## 1.1.2 So how old is the universe? 

library(gamair)
data(hubble)

hub.mod <- lm(y~x-1,data=hubble)
summary(hub.mod)
plot(fitted(hub.mod),residuals(hub.mod),xlab="fitted values",ylab="residuals")

hub.mod1 <- lm(y~x-1,data=hubble[-c(3,15),])
summary(hub.mod1)
plot(fitted(hub.mod1),residuals(hub.mod1),xlab="fitted values",ylab="residuals")
hubble.const <- c(coef(hub.mod),coef(hub.mod1))/3.09e19
age <- 1/hubble.const
age/(60^2*24*365)

## 1.1.3 Adding a distributional assumption
#### Testing Hypotheses about \beta

cs.hubble <- 163000000
t.stat<-(coef(hub.mod1)-cs.hubble)/summary(hub.mod1)$coefficients[2]
pt(t.stat,df=21)*2

#### Confidence intervals

sigb <- summary(hub.mod1)$coefficients[2]
h.ci<-coef(hub.mod1)+qt(c(0.025,0.975),df=21)*sigb
h.ci
h.ci<-h.ci*60^2*24*365.25/3.09e19 # convert to 1/years
sort(1/h.ci)

## 1.5.1 Practical linear modelling

data(sperm.comp1)
pairs(sperm.comp1[,-1])

sc.mod1 <- lm(count~time.ipc+prop.partner,sperm.comp1)
model.matrix(sc.mod1)

par(mfrow=c(2,2))
plot(sc.mod1)

sperm.comp1[9,]
sc.mod1

sc.mod2 <- lm(count~time.ipc+I(prop.partner*time.ipc),sperm.comp1)

## 1.5.2 Model summary

summary(sc.mod1)

## 1.5.3 Model selection

sc.mod3 <- lm(count~prop.partner,sperm.comp1)
summary(sc.mod3) 

sc.mod4 <- lm(count~1,sperm.comp1) # null model
AIC(sc.mod1,sc.mod3,sc.mod4)

## 1.5.4 Another model selection example

data(sperm.comp2)

sc2.mod1<-lm(count~f.age+f.height+f.weight+m.age+m.height+m.weight+m.vol,
             sperm.comp2)
plot(sc2.mod1)
summary(sc2.mod1)

sc2.mod2<-lm(count~f.age+f.height+f.weight+m.height+m.weight+m.vol,sperm.comp2)
summary(sc2.mod2)

## and eventually ...

sc2.mod7<-lm(count~f.weight,sperm.comp2)
summary(sc2.mod7)

sc <- sperm.comp2[-19,] ## drop the gross outlier

sc3.mod1<-lm(count~f.age+f.height+f.weight+m.age+m.height+m.weight+m.vol,sc)
summary(sc3.mod1)

## A follow up

sperm.comp2$m.vol[sperm.comp2$pair%in%sperm.comp1$subject] -> 
sperm.comp1$m.vol

## start from count~time.ipc+prop.partner+m.vol and back select...

sc1.mod1<-lm(count~m.vol,sperm.comp1)
summary(sc1.mod1)

## 1.5.1 Confidence intervals

sc.c <- summary(sc1.mod1)$coefficients
sc.c 
sc.c[2]+qt(c(.025,.975),6)*sc.c[2,2]

## 1.5.6 Prediction

df <- data.frame(m.vol=c(10,15,20,25))
predict(sc1.mod1,df,se=TRUE)

## 1.6.4 Using factor variables in R

z <- c(1,1,1,2,2,1,3,3,3,3,4)
z

z <- as.factor(z)
z

x <- c("A","A","C","C","C","er","er")
x

x <- as.factor(x)
x

PlantGrowth$group

PlantGrowth$group <- as.factor(PlantGrowth$group)

pgm.1 <- lm(weight ~ group,data=PlantGrowth)
plot(pgm.1)
summary(pgm.1)

pgm.0<-lm(weight~1,data=PlantGrowth)
anova(pgm.0,pgm.1)

# R code for chapter 4 of Wood (2006) "GAMs: An Introduction with R"

## 4.11.1 Backfitting GAMs
## setup up some data...
n<-400;sig<-2
x0 <- runif(n, 0, 1);x1 <- runif(n, 0, 1)
x2 <- runif(n, 0, 1);x3 <- runif(n, 0, 1)
f0 <- function(x) 2 * sin(pi * x)
f1 <- function(x) exp(2 * x)
f2 <- function(x) 0.2*x^11*(10*(1-x))^6+10*(10*x)^3*(1-x)^10
f <- f0(x0) + f1(x1) + f2(x2)
e <- rnorm(n, 0, sig)
y <- f + e
x <- cbind(x0,x1,x2,x3)
edf <- c(3,2,7,1.01);m <- 4

## backfit...

f<-x*0;alpha<-mean(y);ok <- TRUE;rss0 <- 0
while (ok) { # backfitting loop
  for (i in 1:m) { # loop through the smooth terms
    ep <- y - rowSums(f[,-i]) - alpha
    b <- smooth.spline(x[,i],ep,df=edf[i])
    f[,i] <- predict(b,x[,i])$y
  }
  rss <- sum((y-rowSums(f))^2)
  if (abs(rss-rss0)<1e-6*rss) ok <- FALSE
  rss0 <- rss
}

# R code for chapter 2 of Wood (2006) "GAMs: An Introduction with R"

## 2.2.2 Geometry and IRLS convergence

x <- c(.6,1.5);y <- c(.02,.9)
ms <- exp(-x*4)   # set initial values at lower left
glm(y~I(-x)-1,family=gaussian(link=log),mustart=ms)
ms <- exp(-x*0.1)  # set initial values at upper right
glm(y~I(-x)-1,family=gaussian(link=log),mustart=ms)

## 2.3.1 Binomial models and heart disease

par(mfrow=c(1,1))
heart <- data.frame(ck = 0:11*40+20,
ha=c(2,13,30,30,21,19,18,13,19,15,7,8),
ok=c(88,26,8,5,0,1,1,1,1,0,0,0))
p<-heart$ha/(heart$ha+heart$ok)
plot(heart$ck,p,xlab="Creatinine kinase level",
     ylab="Proportion Heart Attack")

mod.0 <- glm(cbind(ha,ok)~ck,family=binomial(link=logit),data=heart)
mod.0 <- glm(cbind(ha,ok)~ck,family=binomial,data=heart)

mod.0

(271.7-36.93)/271.7

1-pchisq(36.93,10)

op <- par(mfrow=c(2,2))
plot(mod.0)

par(op)
plot(heart$ck,p,xlab="Creatinine kinase level",ylab="Proportion Heart Attack")
lines(heart$ck,fitted(mod.0))

mod.2 <- glm(cbind(ha,ok)~ck+I(ck^2)+I(ck^3),family=binomial,data=heart)
mod.2

par(mfrow=c(2,2))
plot(mod.2)

par(mfrow=c(1,1))
plot(heart$ck,p,xlab="Creatinine kinase level",ylab="Proportion Heart Attack")
lines(heart$ck,fitted(mod.2))

anova(mod.0,mod.2,test="Chisq")

## 2.3.2 A Poisson regression epidemic model

y <- c(12,14,33,50,67,74,123,141,165,204,253,246,240)
t <- 1:13
plot(t+1980,y,xlab="Year",ylab="New AIDS cases",ylim=c(0,280))

m0 <- glm(y~t,poisson)
m0
par(mfrow=c(2,2))
plot(m0)

m1 <- glm(y~t+I(t^2),poisson)
plot(m1)
summary(m1)

anova(m0,m1,test="Chisq")

beta.1 <- summary(m1)$coefficients[2,]
ci <- c(beta.1[1]-1.96*beta.1[2],beta.1[1]+1.96*beta.1[2])
ci # print 95% CI for beta_1


par(mfrow=c(1,1))
new.t<-seq(1,13,length=100)
fv <- predict(m1,data.frame(t=new.t),se=TRUE)
plot(t+1980,y,xlab="Year",ylab="New AIDS cases",ylim=c(0,280))
lines(new.t+1980,exp(fv$fit))
lines(new.t+1980,exp(fv$fit+2*fv$se.fit),lty=2)
lines(new.t+1980,exp(fv$fit-2*fv$se.fit),lty=2)

## 2.3.3 Log-linear models for catagorical data

al <- data.frame(y=c(435,147,375,134),gender=as.factor(c("F","F","M","M")),
                 faith=as.factor(c(1,0,1,0)))
al

mod.0 <- glm(y~gender+faith,data=al,family=poisson)
model.matrix(mod.0)

mod.0
fitted(mod.0)

mod.1<-glm(y~gender*faith,data=al,family=poisson)
model.matrix(mod.1)
mod.1

anova(mod.0,mod.1,test="Chisq")

## 2.3.4 Sole eggs in the Bristol channel

library(gamair)
data(sole)
sole$off <- log(sole$a.1-sole$a.0)# model offset term
sole$a<-(sole$a.1+sole$a.0)/2     # mean stage age
solr<-sole                        # make copy for rescaling
solr$t<-solr$t-mean(sole$t)
solr$t<-solr$t/var(sole$t)^0.5
solr$la<-solr$la-mean(sole$la)
solr$lo<-solr$lo-mean(sole$lo)
b <- glm(eggs ~ offset(off)+lo+la+t+I(lo*la)+I(lo^2)+I(la^2)
               +I(t^2)+I(lo*t)+I(la*t)+I(lo^3)+I(la^3)+I(t^3)
               +I(lo*la*t)+I(lo^2*la)+I(lo*la^2)+I(lo^2*t)
               +I(la^2*t)+I(la*t^2)+I(lo*t^2)+ a +I(a*t)+I(t^2*a),
         family=quasi(link=log,variance="mu"),data=solr)
summary(b)

b1<-update(b,~.-I(lo*t))
summary(b1) # better plot

b2<-update(b1,~.-I(lo*la*t))
summary(b2) # worse again

b3<-update(b2,~.-I(lo*t^2))
summary(b3) # better again

b4<-update(b3,~.-I(lo^2*t))
summary(b4) # better again

anova(b,b4,test="F")

par(mfrow=c(1,2)) # split graph window into 2 panels
plot(fitted(b4)^0.5,solr$eggs^0.5) # fitted vs. data plot
plot(fitted(b4)^0.5,residuals(b4)) # resids vs. sqrt(fitted)

# R code for chapter 6 of Wood (2006) "GAMs: An Introduction with R"

library(gamair)
data(stomata)

m1 <- lm(area ~ CO2 + tree,stomata)
m0 <- lm(area ~ CO2,stomata)
anova(m0,m1)

m2 <- lm(area ~ tree,stomata)
anova(m2,m1)

st <- aggregate(data.matrix(stomata),
                by=list(tree=stomata$tree),mean)

st$CO2 <- as.factor(st$CO2);st

m3 <- lm(area~CO2,st)
anova(m3)

summary(m3)$sigma^2 - summary(m1)$sigma^2/4

## 6.1.3 A single random factor

library(nlme)  # load nlme `library', which contains data
data(Rail)     # load data
Rail
m1 <- lm(travel ~ Rail,Rail)
anova(m1)


# average over Rail effect...
rt <- aggregate(data.matrix(Rail),by=list(Rail$Rail),mean)
rt

m0 <- lm(travel ~ 1,rt)   # fit model to aggregated data
sigb <- (summary(m0)$sigma^2-summary(m1)$sigma^2/3)^0.5
# sigb^2 is variance component for rail
sig <- summary(m1)$sigma # sig^2 is resid. var. component
sigb
sig

summary(m0)

## 6.1.4 A model with two factors

library(nlme)
data(Machines)
names(Machines)
attach(Machines)  # make data available without `Machines$'
interaction.plot(Machine,Worker,score)

m1 <- lm(score ~ Worker*Machine,Machines)
m0 <- lm(score ~ Worker + Machine,Machines)
anova(m0,m1)

summary(m1)$sigma^2

Mach <- aggregate(data.matrix(Machines),by=
        list(Machines$Worker,Machines$Machine),mean)
Mach$Worker <- as.factor(Mach$Worker)
Mach$Machine <- as.factor(Mach$Machine)

m0 <- lm(score ~ Worker + Machine,Mach)
anova(m0)

summary(m0)$sigma^2 - summary(m1)$sigma^2/3

M <- aggregate(data.matrix(Mach),by=list(Mach$Worker),mean)
m00 <- lm(score ~ 1,M)
summary(m00)$sigma^2 - (summary(m0)$sigma^2)/3

## 6.2.2 Directly maximizing a mixed model likelihood in R

ll <- function(gamma,X,Z,y)
{ # untransform parameters
  sigma.b <- exp(gamma[1])
  sigma <- exp(gamma[2])
  n <- nrow(Z)

  # evaluate covariance matrix for y
  V <- Z%*%t(Z)*sigma.b^2 + diag(n)*sigma^2
  L <- chol(V) # L'L=V

  # transform dependent linear model to indep.
  y <- backsolve(L,y,transpose=TRUE)
  X <- backsolve(L,X,transpose=TRUE)
  b <- coef(lm(y~X-1)) # estimate fixed effects

  # evaluate log likelihood
  logLik <- -n/2*log(2*pi) -  sum (log(diag(L))) -
             sum((y-X%*%b)^2)/2
  attr(logLik,"fixed") <- b # allow retrieval of beta
  logLik
}

options(contrasts=c("contr.treatment","contr.treatment"))
Z <- model.matrix(~Rail$Rail-1)
X <- matrix(1,18,1)

rail.mod <- optim(c(0,0),ll,control=list(fnscale=-1),
                    X=X,Z=Z,y=Rail$travel)

exp(rail.mod$par) # variance components
attr(ll(rail.mod$par,X,Z,Rail$travel),"fixed")

## 6.3 Linear mixed models in R

library(nlme)
lme(travel~1,Rail,list(Rail=~1))

## 6.3.1 Tree growth: An example using `lme'

## NOTE: this example is extremely sensitive to changes in the 
## nlme package.

Loblolly$age <- Loblolly$age - mean(Loblolly$age)
lmc <- lmeControl(niterEM=500,msMaxIter=100)

m0 <- lme(height ~ age + I(age^2) + I(age^3),Loblolly,
          random=list(Seed=~age+I(age^2)+I(age^3)),
          correlation=corAR1(form=~age|Seed),control=lmc)
plot(m0)

m1 <- lme(height ~ age+I(age^2)+I(age^3)+I(age^4),Loblolly,
          list(Seed=~age+I(age^2)+I(age^3)),
          cor=corAR1(form=~age|Seed),control=lmc)
plot(m1)
m2 <- lme(height~age+I(age^2)+I(age^3)+I(age^4)+I(age^5),
          Loblolly,list(Seed=~age+I(age^2)+I(age^3)),
          cor=corAR1(form=~age|Seed),control=lmc)
plot(m2)

plot(m2,Seed~resid(.))
qqnorm(m2,~resid(.))
qqnorm(m2,~ranef(.))

m3 <- lme(height~age+I(age^2)+I(age^3)+I(age^4)+I(age^5),
          Loblolly,list(Seed=~age+I(age^2)+I(age^3)),control=lmc)
anova(m3,m2)

m4 <- lme(height~age+I(age^2)+I(age^3)+I(age^4)+I(age^5),
          Loblolly,list(Seed=~age+I(age^2)),
          correlation=corAR1(form=~age|Seed),control=lmc)
anova(m4,m2)


m5 <- lme(height~age+I(age^2)+I(age^3)+I(age^4)+I(age^5),
          Loblolly,list(Seed=pdDiag(~age+I(age^2)+I(age^3))),
          correlation=corAR1(form=~age|Seed),control=lmc)
anova(m2,m5)

plot(augPred(m2))

## 6.3.2 Several levels of nesting

lme(score~Machine,Machines,list(Worker=~1,Machine=~1))

## 6.5 GLMMs with R

library(MASS)

## NOTE: Have to run ch2.r analysis of these data first!

rf <- residuals(b4,type="d") # extract deviance residuals
## create an identifier for each sampling station
solr$station <- factor(with(solr,paste(-la,-lo,-t,sep="")))

## is there evidence of a station effect in the residuals?
solr$rf <-rf
rm <- lme(rf~1,solr,random=~1|station)
rm0 <- lm(rf~1,solr)
anova(rm,rm0)

b <- glmmPQL(eggs ~ offset(off)+lo+la+t+I(lo*la)+I(lo^2)+
            I(la^2)+I(t^2)+I(lo*t)+I(la*t)+I(lo^3)+I(la^3)+
            I(t^3)+I(lo*la*t)+I(lo^2*la)+I(lo*la^2)+I(lo^2*t)+
            I(la^2*t)+I(la*t^2)+I(lo*t^2) # end log spawn
            + a +I(a*t)+I(t^2*a),random=list(station=~1),
            family=quasi(link=log,variance="mu"),data=solr)
summary(b)

b1<-update(b,~.-I(lo*la*t))
summary(b1) 

b2<-update(b1,~.-I(lo*t))
summary(b2) 

b3<-update(b2,~.-I(lo^2*t))
summary(b3) 

b4<-update(b3,~.-I(la*t^2))
summary(b4) 

fv <- exp(fitted(b4)+solr$off) # note need to add offset
resid <- solr$egg-fv          # raw residuals
plot(fv^.5,solr$eggs^.5)
abline(0,1,lwd=2)
plot(fv^.5,resid/fv^.5)
plot(fv^.5,resid)
fl<-sort(fv^.5)
## add 1 s.d. and 2 s.d. reference lines
lines(fl,fl);lines(fl,-fl);lines(fl,2*fl,lty=2)
lines(fl,-2*fl,lty=2)

intervals(b4,which="var-cov")

## 6.7.1 A GAMM for sole eggs, note parametric `a' term removed,
## as s(t,k=5,by=a) no longer centred (since 1.4-0).

library(mgcv)

bam<-gamm(eggs~te(lo,la,t,bs=c("tp","tp"),k=c(25,5),d=c(2,1))
          +s(t,k=5,by=a)+offset(off),family=quasi(link=log,
          variance="mu"),data=solr,random=list(station=~1))

bam$gam

## 6.7.2 The temperature in Cairo

data(cairo)

ctamm<-gamm(temp~s(day.of.year,bs="cc",k=20)+s(time,bs="cr"),
         data=cairo,correlation=corAR1(form=~1|year))

summary(ctamm$gam)

intervals(ctamm$lme,which="var-cov")

ctamm$gam$sig2/ctamm$gam$sp

ctamm0 <- gamm(temp~s(day.of.year,bs="cc",k=20),data=cairo,
               correlation=corAR1(form=~1|year))
ctamm0$gam

anova(ctamm0$lme,ctamm$lme)
plot(ctamm$gam,scale=0)

# R code for chapter 3 of Wood (2006) "GAMs: An Introduction with R"

## 3.2.1 Representing a smooth function: Regression splines
#### Using the cubic spline basis
par(mfrow=c(1,2))
size <- c(1.42,1.58,1.78,1.99,1.99,1.99,2.13,2.13,2.13,
          2.32,2.32,2.32,2.32,2.32,2.43,2.43,2.78,2.98,2.98)
wear <- c(4.0,4.2,2.5,2.6,2.8,2.4,3.2,2.4,2.6,4.8,2.9,
          3.8,3.0,2.7,3.1,3.3,3.0,2.8,1.7)
x <- size-min(size); x <- x/max(x)
plot(x,wear,xlab="Scaled engine size",ylab="Wear index")

rk<-function(x,z) # R(x,z) for cubic spline on [0,1]
{ ((z-0.5)^2-1/12)*((x-0.5)^2-1/12)/4-
  ((abs(x-z)-0.5)^4-(abs(x-z)-0.5)^2/2+7/240)/24
}

spl.X<-function(x,xk)
# set up model matrix for cubic penalized regression spline
{ q<-length(xk)+2  # number of parameters
  n<-length(x)     # number of data
  X<-matrix(1,n,q) # initialized model matrix
  X[,2]<-x         # set second column to x
  X[,3:q]<-outer(x,xk,FUN=rk) # and remaining to R(x,xk)
  X
}

xk<-1:4/5      # choose some knots
X<-spl.X(x,xk) # generate model matrix
mod.1<-lm(wear~X-1) # fit model
xp<-0:100/100    # x values for prediction
Xp<-spl.X(xp,xk) # prediction matrix
lines(xp,Xp%*%coef(mod.1)) # plot fitted spline

## 3.2.2 Controlling the degree of smoothing with penalized regression splines

spl.S<-function(xk)
# set up the penalized regression spline penalty matrix,
# given knot sequence xk
{ q<-length(xk)+2;S<-matrix(0,q,q) # initialize matrix to 0
  S[3:q,3:q]<-outer(xk,xk,FUN=rk)  # fill in non-zero part
  S
}

mat.sqrt<-function(S) # A simple matrix square root
{ d<-eigen(S,symmetric=TRUE)
  rS<-d$vectors%*%diag(d$values^0.5)%*%t(d$vectors)
}

prs.fit<-function(y,x,xk,lambda)
# function to fit penalized regression spline to x,y data,
# with knots xk, given smoothing parameter, lambda.
{ q<-length(xk)+2           # dimension of basis
  n<-length(x)              # number of data
  # create augmented model matrix ....
  Xa <- rbind(spl.X(x,xk),mat.sqrt(spl.S(xk))*sqrt(lambda))
  y[(n+1):(n+q)]<-0  # augment the data vector
  lm(y~Xa-1) # fit and return penalized regression spline
}

xk<-1:7/8  # choose some knots
mod.2<-prs.fit(wear,x,xk,0.0001) # fit pen. reg. spline
Xp<-spl.X(xp,xk) # matrix to map params to fitted values at xp
plot(x,wear);lines(xp,Xp%*%coef(mod.2)) # plot data & spl. fit

## 3.2.3 Choosing the smoothing parameter, \lambda: Cross validation

lambda<-1e-8;n<-length(wear);V<-rep(0,60)
for (i in 1:60)            # loop through smoothing parameters
{ mod<-prs.fit(wear,x,xk,lambda)     # fit model, given lambda
  trA<-sum(influence(mod)$hat[1:n])  # find tr(A)
  rss<-sum((wear-fitted(mod)[1:n])^2)# residual sum of squares
  V[i]<-n*rss/(n-trA)^2              # obtain GCV score
  lambda<-lambda*1.5                 # increase lambda
}
plot(1:60,V,type="l",main="GCV score",xlab="i")  # plot score

i<-(1:60)[V==min(V)]                 # extract index of min(V)
mod.3<-prs.fit(wear,x,xk,1.5^(i-1)*1e-8)  # fit optimal model
Xp<-spl.X(xp,xk)                          # .... and plot it
plot(x,wear);lines(xp,Xp%*%coef(mod.3))

## 3.3.1 Penalized regression spline representation of an additive model

am.setup<-function(x,z,q=10)
# Get X, S_1 and S_2 for a simple 2 term AM
{ # choose knots ...
  xk <- quantile(unique(x),1:(q-2)/(q-1))
  zk <- quantile(unique(z),1:(q-2)/(q-1))
  # get penalty matrices ...
  S <- list()
  S[[1]] <- S[[2]] <- matrix(0,2*q-1,2*q-1)
  S[[1]][2:q,2:q] <- spl.S(xk)[-1,-1]
  S[[2]][(q+1):(2*q-1),(q+1):(2*q-1)] <- spl.S(zk)[-1,-1]
  # get model matrix ...
  n<-length(x)
  X<-matrix(1,n,2*q-1)
  X[,2:q]<-spl.X(x,xk)[,-1]           # 1st smooth
  X[,(q+1):(2*q-1)]<-spl.X(z,zk)[,-1] # 2nd smooth
  list(X=X,S=S)
}

fit.am<-function(y,X,S,sp)
# function to fit simple 2 term additive model
{ # get sqrt of total penalty matrix ...
  rS <- mat.sqrt(sp[1]*S[[1]]+sp[2]*S[[2]])
  q.tot <- ncol(X)                # number of params
  n <- nrow(X)                    # number of data
  X1 <- rbind(X,rS)               # augmented X
  y1 <- c(y,rep(0,q.tot))         # augment data
  b<-lm(y1~X1-1)                  # fit model
  trA<-sum(influence(b)$hat[1:n]) # tr(A)
  norm<-sum((y-fitted(b)[1:n])^2) # RSS
  list(model=b,gcv=norm*n/(n-trA)^2,sp=sp)
}

data(trees)
rg <- range(trees$Girth)
trees$Girth <- (trees$Girth - rg[1])/(rg[2]-rg[1])
rh <- range(trees$Height)
trees$Height <- (trees$Height - rh[1])/(rh[2]-rh[1])

am0 <- am.setup(trees$Girth,trees$Height)

sp<-c(0,0)   # initialize smoothing parameter (s.p.) array
for (i in 1:30) for (j in 1:30)      # loop over s.p. grid
{ sp[1]<-1e-5*2^(i-1);sp[2]<-1e-5*2^(j-1) # s.p.s
  b<-fit.am(trees$Volume,am0$X,am0$S,sp)  # fit using s.p.s
  if (i+j==2) best<-b else                # store 1st model
  if (b$gcv<best$gcv) best<-b             # store best model
}
best$sp   # GCV best smoothing parameters found

# plot fitted against data ...
plot(trees$Volume,fitted(best$model)[1:31],
     xlab="Fitted Volume",ylab="Actual Volume")
# evaluate and plot f_1 against Girth ...
b<-best$model
b$coefficients[1]<-0     # zero the intercept
b$coefficients[11:19]<-0 # zero the second smooth coefs
f0<-predict(b)           # predict f_1 only, at data values
plot(trees$Girth,f0[1:31],xlab="Scaled Girth",
     ylab=expression(hat(f[1])))


## 3.4 Generalized Additive Models

fit.gamG<-function(y,X,S,sp)
# function to fit simple 2 term generalized additive model
# Gamma errors and log link
{ # get sqrt of combined penalty matrix ...
  rS <- mat.sqrt(sp[1]*S[[1]]+sp[2]*S[[2]])
  q <- ncol(X)   # number of params
  n <- nrow(X)   # number of data
  X1 <- rbind(X,rS)     # augmented model matrix
  eta <- log(y)         # initialize linear predictor
  norm <- 0;old.norm <- 1   # initialize convergence control
  while (abs(norm-old.norm)>1e-4*norm)  # repeat un-converged
  { mu <- exp(eta)          # fitted values
    z <- (y-mu)/mu + eta    # pseudodata (recall w_i=1, here)
    z[(n+1):(n+q)] <- 0     # augmented pseudodata
    m <- lm(z~X1-1)         # fit penalized working model
    b <- m$coefficients     # current parameter estimates
    eta <- (X1%*%b)[1:n]    # 'linear predictor'
    trA <- sum(influence(m)$hat[1:n]) # tr(A)
    old.norm <- norm        # store for convergence test
    norm <- sum((z-fitted(m))[1:n]^2) # RSS of working model
  }
  list(model=m,gcv=norm*n/(n-trA)^2,sp=sp)
}
